LightOJ1316 A Wedding Party(状压DP)

这题事实上只需要关心15个商店和一个起点一个终点,预处理出这几个点之间的最短距离。Floyd会超时,用Dijkstra即可。

然后就是dp[u][S]表示已经经过商店集合S且当前在第u个商店所花的最少时间。

最后的结果是找到所有dp[u][S]有解且u能到达终点的最大的|S|,而最短时间就是dp[u][S]+dist[u][vt]。

细节还挺多的。

 1 #include<cstdio>
 2 #include<cstring>
 3 #include<algorithm>
 4 using namespace std;
 5 #define INF (1<<29)
 6
 7 int d[15][1<<15];
 8 int G[555][555],dist[555][555],shop[15];
 9 void dijkstra(int vs,int n){
10     for(int i=0; i<n; ++i) dist[vs][i]=INF;
11     dist[vs][vs]=0;
12     bool vis[555]={0};
13     for(int i=0; i<n; ++i){
14         int u=-1,mm=INF;
15         for(int v=0; v<n; ++v){
16             if(!vis[v] && mm>dist[vs][v]){
17                 mm=dist[vs][v];
18                 u=v;
19             }
20         }
21         if(u==-1) break;
22         vis[u]=1;
23         for(int v=0; v<n; ++v){
24             if(!vis[v] && G[u][v]!=INF && dist[vs][v]>dist[vs][u]+G[u][v]){
25                 dist[vs][v]=dist[vs][u]+G[u][v];
26             }
27         }
28     }
29 }
30 int getCnt(int s){
31     int res=0;
32     for(int i=0; i<15; ++i){
33         if((s>>i)&1) ++res;
34     }
35     return res;
36 }
37 int cnt[1<<15];
38 int main(){
39     for(int i=0; i<(1<<15); ++i) cnt[i]=getCnt(i);
40     int t,n,m,s,a,b,c;
41     scanf("%d",&t);
42     for(int cse=1; cse<=t; ++cse){
43         scanf("%d%d%d",&n,&m,&s);
44         for(int i=0; i<n; ++i){
45             for(int j=0; j<n; ++j) G[i][j]=INF;
46         }
47         for(int i=0; i<s; ++i) scanf("%d",&shop[i]);
48         while(m--){
49             scanf("%d%d%d",&a,&b,&c);
50             G[a][b]=min(G[a][b],c);
51         }
52         dijkstra(0,n);
53         for(int i=0; i<s; ++i) dijkstra(shop[i],n);
54
55         if(dist[0][n-1]==INF){
56             printf("Case %d: Impossible\n",cse);
57             continue;
58         }
59
60         for(int i=0; i<s; ++i){
61             for(int j=0; j<(1<<s); ++j) d[i][j]=INF;
62         }
63         for(int i=0; i<s; ++i){
64             d[i][1<<i]=dist[0][shop[i]];
65         }
66         for(int i=1; i<(1<<s); ++i){
67             for(int j=0; j<s; ++j){
68                 if(((i>>j)&1)==0) continue;
69                 for(int k=0; k<s; ++k){
70                     if(k==j || ((i>>k)&1)==0) continue;
71                     d[j][i]=min(d[j][i],d[k][i^(1<<j)]+dist[shop[k]][shop[j]]);
72                 }
73             }
74         }
75         int mx=0,mm=INF;
76         for(int i=1; i<(1<<s); ++i){
77             for(int j=0; j<s; ++j){
78                 if(d[j][i]==INF || dist[shop[j]][n-1]==INF) continue;
79                 mx=max(mx,cnt[i]);
80             }
81         }
82         for(int i=1; i<(1<<s); ++i){
83             for(int j=0; j<s; ++j){
84                 if(d[j][i]==INF) continue;
85                 if(cnt[i]==mx) mm=min(mm,d[j][i]+dist[shop[j]][n-1]);
86             }
87         }
88         if(mm!=INF) printf("Case %d: %d %d\n",cse,mx,mm);
89         else printf("Case %d: 0 %d\n",cse,dist[0][n-1]);
90     }
91     return 0;
92 }
时间: 2024-10-12 12:43:25

LightOJ1316 A Wedding Party(状压DP)的相关文章

ZOJ3305Get Sauce 状压DP,

状压DP的题目留个纪念,首先题意一开始读错了,搞了好久,然后弄好了,觉得DFS可以,最后超时,修改了很久还是超时,没办法看了一下n的范围,然后觉得状压可以,但是没有直接推出来,就记忆化搜索了一下,可是一直错,莫名奇妙,然后没办法看了一下题解,发现了下面这个比较好的方法,然后按照这个方程去推,然后敲,也是WA了好多把,写的太搓了,没人家的清楚明了,唉~也算是给自己留个纪念,状压一直做的都不太好~唉~还好理解了, 参考了  http://blog.csdn.net/nash142857/articl

poj 2411 Mondriaan&#39;s Dream(状压DP)

Mondriaan's Dream Time Limit: 3000MS   Memory Limit: 65536K Total Submissions: 12232   Accepted: 7142 Description Squares and rectangles fascinated the famous Dutch painter Piet Mondriaan. One night, after producing the drawings in his 'toilet series

(状压dp)uva 10817 Headmaster&#39;s Headache

题目地址 1 #include <bits/stdc++.h> 2 typedef long long ll; 3 using namespace std; 4 const int MAX=1e5+5; 5 const int INF=1e9; 6 int s,m,n; 7 int cost[125]; 8 //char sta[MAX]; 9 string sta; 10 int able[125]; 11 int dp[125][1<<8][1<<8]; 12 in

HDU5816 Hearthstone(状压DP)

题目 Source http://acm.hdu.edu.cn/showproblem.php?pid=5816 Description Hearthstone is an online collectible card game from Blizzard Entertainment. Strategies and luck are the most important factors in this game. When you suffer a desperate situation an

HDU 4336 容斥原理 || 状压DP

状压DP :F(S)=Sum*F(S)+p(x1)*F(S^(1<<x1))+p(x2)*F(S^(1<<x2))...+1; F(S)表示取状态为S的牌的期望次数,Sum表示什么都不取得概率,p(x1)表示的是取x1的概率,最后要加一因为有又多拿了一次.整理一下就可以了. 1 #include <cstdio> 2 const int Maxn=23; 3 double F[1<<Maxn],p[Maxn]; 4 int n; 5 int main() 6

Travel(HDU 4284状压dp)

题意:给n个城市m条路的网图,pp在城市1有一定的钱,想游览这n个城市(包括1),到达一个城市要一定的花费,可以在城市工作赚钱,但前提有工作证(得到有一定的花费),没工作证不能在该城市工作,但可以走,一个城市只能工作一次,问pp是否能游览n个城市回到城市1. 分析:这个题想到杀怪(Survival(ZOJ 2297状压dp) 那个题,也是钱如果小于0就挂了,最后求剩余的最大钱数,先求出最短路和 Hie with the Pie(POJ 3311状压dp) 送披萨那个题相似. #include <

BZOJ 1087: [SCOI2005]互不侵犯King( 状压dp )

简单的状压dp... dp( x , h , s ) 表示当前第 x 行 , 用了 h 个 king , 当前行的状态为 s . 考虑转移 : dp( x , h , s ) = ∑ dp( x - 1 , h - cnt_1( s ) , s' ) ( s and s' 两行不冲突 , cnt_1( s ) 表示 s 状态用了多少个 king ) 我有各种预处理所以 code 的方程和这有点不一样 ------------------------------------------------

BZOJ 1072 排列 状压DP

题意:链接 方法:状压DP? 题解:这题其实没啥好写的,不算很难,推一推就能搞出来. 首先看到这个问题,对于被d整除这个条件,很容易就想到是取余数为0,所以想到可能状态中刚开始含有取余数. 先说我的第一个想法,f[i][j]表示选取i个数且此时的mod为j,这样的思想是第一下蹦出来的,当时想的就是在线来搞最终的答案.不过转瞬即发现,这TM不就是暴力吗魂淡!并没有什么卵用,于是开始想这个状态可不可以做什么优化. 显然第二维的j并不需要太大的优化,暂且先将其搁置一边,来考虑第一维的i怎么优化. 把滚

COdeforces#417D Cunning Gena(状压DP)

A boy named Gena really wants to get to the "Russian Code Cup" finals, or at least get a t-shirt. But the offered problems are too complex, so he made an arrangement with his n friends that they will solve the problems for him. The participants

UVA 10817 Headmaster&#39;s Headache 状压DP

记录两个状态S1,S2分别记录哪些课程被1个人教过或2个人教过,然后记忆化搜索 UVA - 10817 Headmaster's Headache Time Limit: 3000MS   Memory Limit: Unknown   64bit IO Format: %lld & %llu Submit Status Description Problem D: Headmaster's Headache Time limit: 2 seconds The headmaster of Spr